function [ec] = alg_grover(f,n,s)

// ec = alg_grover(f,n,s)
//  Algoritmo de Grover, aplicado a la funcion f, de dimension 2^n. s es el
//  numero de soluciones que tiene f.
//
//  ejemplos: 
//   alg_grover(f_ej5,3,1)

// primero construyo las compuertas
tWn = t_W(n);
Uf = U_grover(f,n);
tG = t_G(n);
iters = floor(%pi*sqrt(2^n)/4);

// Algoritmo
// Tomar como estado inicial el n-qubit |0> y 
// aplicar la transformada de Walsh-Hadamard.
eci = tWn*e(0,n);
for i=1:iters
    // Aplicar U : |x> -> (-1)^f(x)|x> y 
    // G = 2|x><x| - I
    eci = tG*Uf*eci;
end

// grafico amplitud final
bar([0:length(eci)-1],eci,'r');
xtitle('Amplitud de |x>','|x>','Amplitud');
    
ec = medicion(normal(eci));

endfunction

