function [k] = alg_simon(f,n,arg_f)

// k = alg_shor(f,n,arg_f)
//  Calcula k, aplicando el circuito de Simon. f es la funcion periodica, d es la dimension
//  del dominio y codominio de f y arg f es el argumento de f.
//
//  ejemplo:
//    alg_simon(f_mod2,2)

hay_args = %f;
if (argn(2) == 3), hay_args = %t; end

if (hay_args)
    Uf = U_f(f,n,n,arg_f);
else
    Uf = U_f(f,n,n);
end

tWn = t_W(n);

A = Uf*kron(tWn*e(0,n),e(0,n));
for i=n:2*n
    A = medicion(A,i);
end

k = medicion(kron(tWn,t_I(n))*A);

endfunction
