function [mec] = medicion(ec,n)

// mec = medicion(ec,n)
//  Realiza la medicion del n-qubit del estado cuantico, utilizando la base canonica.

medir_todos = %t;
if (argn(2) == 2), medir_todos = %f; end

if (~es_normal(ec)), ec = normal(ec); end

ec2 = abs(ec).^2;
coefs = cumsum(ec2);

r = rand();
j = 1;
while (coefs(j) < r)
    j = j+1;
end

dim = length(ec);
mec = zeros(dim,1);

if (~medir_todos)
    bits = log2(length(ec));
    se = ext_bit(j-1,bits-n);                 // determino el subespacio que quiero medir
    sev = (ext_bit(0:dim-1,bits-n) == se)*1;  // determino, de todos los elementos de la base canonica,
                                              // los que pertenecen a ese subespacio
    mec(:) = sev(:).*ec(:);
    mec = normal(mec);                             // normalizo el vector
else
    mec(j) = 1;
end

endfunction

