function [Cont] = t_Cont(bits,T)

// Cont = t_Cont(bits,T)
//  Transformacion controlada, donde bits es la cantidad de bits totales de
//  la transformacion y T es la propia transformacion. Por ejemplo:
//  t_Cont(2,t_X) es la transformacion C_12, t_Cont(3,t_X) es la
//  transformacion de Toffoli.

[i,j] = size(T);
if (i ~= j), error('Transformacion no cuadrada.'); end

d = 2^bits;
relleno = d - i;
if (relleno < 1), error('No se puede construir una transformacion controlada con esa cantidad de bits'); end

Cont = eye(d,d);

Cont(relleno+1:d,relleno+1:d) = T;

endfunction
